/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */
 
 
#include "barra.h"

/*****************************
**
** CLASE BARRA
**
******************************/

 Barra::Barra(Juego *j) {
	char tmpch[127];
	Frame frBarra, frVida;
	Frame frBarraPoder0, frBarraPoder1, frBarraPoder2, frBarraPoder3, frBarraPoder4;
	Frame frCangrejo0, frCangrejo1;
	Frame frPoderes0, frPoderes1, frPoderes2, frPoderes3, frPoderes4;
	Frame frCompuerta0;
	Frame frLuces0, frLuces1, frLuces2;
	Frame frTxtPuntos, frTxtNPoderes, frTxtFase, frTxtNivel, frTxtPersonaje;
	 
	pantalla_w = 640;
	pantalla_h = 480;
	sizeFontCartel = 9;
	sizeFontPuntos = 16;
	sizeFontPoderes = 17;
	 
	ciclosParpadeoCangrejo = 120;
	 
	auxPuntos = -1;
	auxNPoderes = -1; 
	auxNivel = -1;
	auxPersonaje = PERS_PACOALBA;
	 
	 // fondo de barra	 
	sprintf (tmpch, "%s/barra.tim", DATA_DIR);
	frBarra.loadFromRAR(tmpch, "barra.timp");
	barra = new Elemento();
	barra->addFrame(frBarra);
	barra->setX(510);
	barra->setY(0);
	
	// vidas

	frVida.loadFromRAR(tmpch, "vidas.timp");
	for (int i=0; i<7; i++) {
		vida[i] = new Elemento();
		vida[i]->addFrame(frVida);
		vida[i]->setX(xEnPantalla(620) - vida[i]->getAncho() - (i * 20));
		vida[i]->setY(yEnPantalla(87));
	}
	
	// barra de poder
	barra_poder = new Elemento(5);
	frBarraPoder0.loadFromRAR(tmpch, "barra_poder0.timp");
	barra_poder->addFrame(frBarraPoder0);
	frBarraPoder1.loadFromRAR(tmpch, "barra_poder1.timp");
	barra_poder->addFrame(frBarraPoder1);
	frBarraPoder2.loadFromRAR(tmpch, "barra_poder2.timp");
	barra_poder->addFrame(frBarraPoder2);
	frBarraPoder3.loadFromRAR(tmpch, "barra_poder3.timp");
	barra_poder->addFrame(frBarraPoder3);
	frBarraPoder4.loadFromRAR(tmpch, "barra_poder4.timp");
	barra_poder->addFrame(frBarraPoder4);
	barra_poder->setX(xEnPantalla(521));
	barra_poder->setY(yEnPantalla(128));
	
	
	// luces
	luces = new Elemento(3);
	frLuces0.loadFromRAR(tmpch, "barra_luzr.timp");
	luces->addFrame(frLuces0);
	frLuces1.loadFromRAR(tmpch, "barra_luzv.timp");
	luces->addFrame(frLuces1);
	frLuces2.loadFromRAR(tmpch, "barra_luza.timp");
	luces->addFrame(frLuces2);
	luces->setX(xEnPantalla(523));
	luces->setY(yEnPantalla(275));

	// poderes	
	poderes = new Elemento(5);
	frPoderes0.loadFromRAR(tmpch, "barra_poderes0.timp");
	poderes->addFrame(frPoderes0);
	frPoderes1.loadFromRAR(tmpch, "barra_poderes1.timp");
	poderes->addFrame(frPoderes1);
	frPoderes2.loadFromRAR(tmpch, "barra_poderes2.timp");
	poderes->addFrame(frPoderes2);
	frPoderes3.loadFromRAR(tmpch, "barra_poderes3.timp");
	poderes->addFrame(frPoderes3);
	frPoderes4.loadFromRAR(tmpch, "barra_poderes4.timp");
	poderes->addFrame(frPoderes4);
	poderes->setAlign(ALIGN_CENTER);
	poderes->setVAlign(VALIGN_CENTER);
	poderes->setX(xEnPantalla(580));
	poderes->setY(yEnPantalla(204));

	
	// compuerta
	compuerta = new Elemento();
	frCompuerta0.loadFromRAR(tmpch, "compuertas.timp");
	compuerta->addFrame(frCompuerta0);
	compuerta->setX(xEnPantalla(546));
	compuerta->setY(yEnPantalla(312));
	
	
	// personaje paco
	
	sprintf (tmpch, "%s/intercom.tim", DATA_DIR);
	
	Frame frCompuertaAbrir0, frCompuertaAbrir1, frCompuertaAbrir2, frCompuertaAbrir3;
	Frame frPaco0, frPaco1, frPaco2, frPaco3;
	Frame frBizcone0, frBizcone1, frBizcone2, frBizcone3;
	Frame frMadre0, frMadre1, frMadre2, frMadre3;
	Frame frSuperman0, frSuperman1, frSuperman2, frSuperman3;

	persPaco = new Elemento(12);

	frCompuertaAbrir0.loadFromRAR(tmpch, "compuertas_abrir0.timp");
	persPaco->addFrame(frCompuertaAbrir0);
	frCompuertaAbrir1.loadFromRAR(tmpch, "compuertas_abrir1.timp");
	persPaco->addFrame(frCompuertaAbrir1);
	frCompuertaAbrir2.loadFromRAR(tmpch, "compuertas_abrir2.timp");
	persPaco->addFrame(frCompuertaAbrir2);
	frCompuertaAbrir3.loadFromRAR(tmpch, "compuertas_abrir3.timp");
	persPaco->addFrame(frCompuertaAbrir3);

	frPaco0.loadFromRAR(tmpch, "paco_int0.timp");
	persPaco->addFrame(frPaco0);
	frPaco1.loadFromRAR(tmpch, "paco_int1.timp");
	persPaco->addFrame(frPaco1);
	frPaco2.loadFromRAR(tmpch, "paco_int2.timp");
	persPaco->addFrame(frPaco2);
	frPaco3.loadFromRAR(tmpch, "paco_int3.timp");
	persPaco->addFrame(frPaco3);

	persPaco->addFrame(frCompuertaAbrir3);
	persPaco->addFrame(frCompuertaAbrir2);
	persPaco->addFrame(frCompuertaAbrir1);
	persPaco->addFrame(frCompuertaAbrir0);
	
	persPaco->setX(xEnPantalla(546));
	persPaco->setY(yEnPantalla(312));
	
	persPaco->selFrame(0);
	
	persBizcone = new Elemento(12);

	persBizcone->addFrame(frCompuertaAbrir0);
	persBizcone->addFrame(frCompuertaAbrir1);
	persBizcone->addFrame(frCompuertaAbrir2);
	persBizcone->addFrame(frCompuertaAbrir3);

	frBizcone0.loadFromRAR(tmpch, "bizcone_int0.timp");
	persBizcone->addFrame(frBizcone0);
	frBizcone1.loadFromRAR(tmpch, "bizcone_int1.timp");
	persBizcone->addFrame(frBizcone1);
	frBizcone2.loadFromRAR(tmpch, "bizcone_int2.timp");
	persBizcone->addFrame(frBizcone2);
	frBizcone3.loadFromRAR(tmpch, "bizcone_int3.timp");
	persBizcone->addFrame(frBizcone3);

	persBizcone->addFrame(frCompuertaAbrir3);
	persBizcone->addFrame(frCompuertaAbrir2);
	persBizcone->addFrame(frCompuertaAbrir1);
	persBizcone->addFrame(frCompuertaAbrir0);
	
	persBizcone->setX(xEnPantalla(546));
	persBizcone->setY(yEnPantalla(312));
	
	persBizcone->selFrame(0);
	
	persMadre = new Elemento(12);

	persMadre->addFrame(frCompuertaAbrir0);
	persMadre->addFrame(frCompuertaAbrir1);
	persMadre->addFrame(frCompuertaAbrir2);
	persMadre->addFrame(frCompuertaAbrir3);

	frMadre0.loadFromRAR(tmpch, "madre_int0.timp");
	persMadre->addFrame(frMadre0);
	frMadre1.loadFromRAR(tmpch, "madre_int1.timp");
	persMadre->addFrame(frMadre1);
	frMadre2.loadFromRAR(tmpch, "madre_int2.timp");
	persMadre->addFrame(frMadre2);
	frMadre3.loadFromRAR(tmpch, "madre_int3.timp");
	persMadre->addFrame(frMadre3);

	persMadre->addFrame(frCompuertaAbrir3);
	persMadre->addFrame(frCompuertaAbrir2);
	persMadre->addFrame(frCompuertaAbrir1);
	persMadre->addFrame(frCompuertaAbrir0);
	
	persMadre->setX(xEnPantalla(546));
	persMadre->setY(yEnPantalla(312));
	
	persMadre->selFrame(0);
	
	persSuperman = new Elemento(12);

	persSuperman->addFrame(frCompuertaAbrir0);
	persSuperman->addFrame(frCompuertaAbrir1);
	persSuperman->addFrame(frCompuertaAbrir2);
	persSuperman->addFrame(frCompuertaAbrir3);

	frSuperman0.loadFromRAR(tmpch, "superman_int0.timp");
	persSuperman->addFrame(frSuperman0);
	frSuperman1.loadFromRAR(tmpch, "superman_int1.timp");
	persSuperman->addFrame(frSuperman1);
	frSuperman2.loadFromRAR(tmpch, "superman_int2.timp");
	persSuperman->addFrame(frSuperman2);
	frSuperman3.loadFromRAR(tmpch, "superman_int3.timp");
	persSuperman->addFrame(frSuperman3);

	persSuperman->addFrame(frCompuertaAbrir3);
	persSuperman->addFrame(frCompuertaAbrir2);
	persSuperman->addFrame(frCompuertaAbrir1);
	persSuperman->addFrame(frCompuertaAbrir0);
	
	persSuperman->setX(xEnPantalla(546));
	persSuperman->setY(yEnPantalla(312));
	
	persSuperman->selFrame(0);
	
	SDL_Surface *surface;
	txtPuntos = new Elemento();
	sprintf (tmpch, "%d", j->getPuntos());
	surface = f->escribirTexto(0, 14, tmpch, 255, 255, 255, 0, 0, 0);
	frTxtPuntos.loadSurface(surface);
	txtPuntos->addFrame(frTxtPuntos);
	txtPuntos->setX(xEnPantalla(617));
	txtPuntos->setY(yEnPantalla(50));
	txtPuntos->setAlign(ALIGN_RIGHT);
	txtPuntos->setVAlign(VALIGN_TOP);
	
	txtNPoderes = new Elemento();
	sprintf (tmpch, "%d", j->getPoderes());
	surface = f->escribirTexto(0, sizeFontPoderes, tmpch, 255, 230, 23, 0, 0, 0);
	frTxtNPoderes.loadSurface(surface);
	txtNPoderes->addFrame(frTxtNPoderes);
	txtNPoderes->setX(xEnPantalla(605));
	txtNPoderes->setY(yEnPantalla(135));
	txtNPoderes->setAlign(ALIGN_CENTER);
	txtNPoderes->setVAlign(VALIGN_CENTER);
	
	txtNivel = new Elemento();
	surface = f->escribirTexto(0, sizeFontCartel, j->getTituloNumeroFase(), 255, 230, 23, 0, 0, 0);
	frTxtNivel.loadSurface(surface);
	txtNivel->addFrame(frTxtNivel);
	txtNivel->setX(xEnPantalla(582));
	txtNivel->setY(yEnPantalla(448));
	txtNivel->setAlign(ALIGN_CENTER);
	txtNivel->setVAlign(VALIGN_TOP);
	
	txtFase = new Elemento();
	surface = f->escribirTexto(0, sizeFontCartel, j->getTituloNombreCortoFase(), 255, 255, 255, 0, 0, 0);
	frTxtFase.loadSurface(surface);
	txtFase->addFrame(frTxtFase);
	txtFase->setX(xEnPantalla(582));
	txtFase->setY(yEnPantalla(458));
	txtFase->setAlign(ALIGN_CENTER);
	txtFase->setVAlign(VALIGN_TOP);
	
	txtPersonaje = new Elemento();
	surface = f->escribirTexto(0, 8, "PACO ALBA", 255, 230, 23, 0, 0, 0);
	frTxtPersonaje.loadSurface(surface);
	txtPersonaje->addFrame(frTxtPersonaje);
	txtPersonaje->setX(xEnPantalla(585));
	txtPersonaje->setY(yEnPantalla(282));
	txtPersonaje->setAlign(ALIGN_CENTER);
	txtPersonaje->setVAlign(VALIGN_TOP);
	txtPersonaje->setParpadeo(6);
	
}

int Barra::xEnPantalla (int x) {
	if (pantalla_w != 640) {
		return pantalla_w * x / 520;
	}
	return x;
}

int Barra::yEnPantalla (int y) {
	if (pantalla_h != 480) {
		return pantalla_h * y / 480;
	}
	return y;
}

void Barra::dibujarBarra(SDL_Surface *screen, Juego *juego, Intercom *i) {
	SDL_Surface *surface;
	char tmpuntos[10];
	char tmpNumeroPoderes[10] ;

	// dibujar compuertas
	if (i->getIntercomAbierto() == 1) {
		juego->setHacerClip(0);
		switch(i->getPersonajeIntercom()) {
			case PERS_PACOALBA:
				if (juego->getCiclos()%6==0) {
					if (persPaco->getActualFrame()>6) {
						persPaco->selFrame(4);
					} else {
						persPaco->selSiguienteFrame();
					}
				}
				persPaco->dibujar(screen);
			break;
			case PERS_BIZCONE:
				if (juego->getCiclos()%6==0) {
					if (persBizcone->getActualFrame()>6) {
						persBizcone->selFrame(4);
					} else {
						persBizcone->selSiguienteFrame();
					}
				}
				persBizcone->dibujar(screen);
			break;
			case PERS_MADRE:
				if (juego->getCiclos()%6==0) {
					if (persMadre->getActualFrame()>6) {
						persMadre->selFrame(4);
					} else {
						persMadre->selSiguienteFrame();
					}
				}
				persMadre->dibujar(screen);
			break;
			case PERS_SUPERMAN:
				if (juego->getCiclos()%6==0) {
					if (persSuperman->getActualFrame()>6) {
						persSuperman->selFrame(4);
					} else {
						persSuperman->selSiguienteFrame();
					}
				}
				persSuperman->dibujar(screen);
			break;
		}
	} else {
		if (persPaco->getActualFrame() != 0) {
			juego->setHacerClip(0);
			if (juego->getCiclos()%6==0) {
				if (persPaco->getActualFrame()>11) {
					persPaco->selFrame(0);
					compuerta->dibujar(screen);
				} else {
					persPaco->selSiguienteFrame();
				}
			}
			persPaco->dibujar(screen);
		} else if (persBizcone->getActualFrame() != 0) {
			juego->setHacerClip(0);
			if (juego->getCiclos()%6==0) {
				if (persBizcone->getActualFrame()>11) {
					persBizcone->selFrame(0);
					compuerta->dibujar(screen);
				} else {
					persBizcone->selSiguienteFrame();
				}
			}
			persBizcone->dibujar(screen);
		} else if (persMadre->getActualFrame() != 0) {
			juego->setHacerClip(0);
			if (juego->getCiclos()%6==0) {
				if (persMadre->getActualFrame()>11) {
					persMadre->selFrame(0);
					compuerta->dibujar(screen);
				} else {
					persMadre->selSiguienteFrame();
				}
			}
			persMadre->dibujar(screen);
		} else if (persSuperman->getActualFrame() != 0) {
			juego->setHacerClip(0);
			if (juego->getCiclos()%6==0) {
				if (persSuperman->getActualFrame()>11) {
					persSuperman->selFrame(0);
					compuerta->dibujar(screen);
				} else {
					persSuperman->selSiguienteFrame();
				}
			}
			persSuperman->dibujar(screen);
		} else {
			compuerta->dibujar(screen);
		}
	}
	
	// dibujar fondo de barra
	barra->dibujar(screen);
	
	
	// dibujar barra de poder
	if ( juego->getBarraPoder() == 3) {
		ciclosParpadeoCangrejo = 0;
		juego->addBarraPoder();
		//juego->addPoderes();
	} else if ( juego->getBarraPoder() > 3) {
		if ( ciclosParpadeoCangrejo > 80) {
			ciclosParpadeoCangrejo = 120;
			juego->setBarraPoder(0);
		}
		
		if ( ciclosParpadeoCangrejo % 10 > 5) {
				// numero de poderes
				if (auxNPoderes != juego->getPoderes()) {
					sprintf (tmpNumeroPoderes, "%d", juego->getPoderes());
					surface = f->escribirTexto(0, sizeFontPoderes, tmpNumeroPoderes, 255, 255, 255, 0, 0, 0);
					txtNPoderes->sprite[0].img = surface;
					auxNPoderes = juego->getPoderes();
				}
				txtNPoderes->dibujar(screen);
		}
		ciclosParpadeoCangrejo++;
		juego->setHacerClip(0);
	} else {
		// numero de poderes
		if (auxNPoderes != juego->getPoderes()) {
			sprintf (tmpNumeroPoderes, "%d", juego->getPoderes());
			surface = f->escribirTexto(0, sizeFontPoderes, tmpNumeroPoderes, 255, 255, 255, 0, 0, 0);
			txtNPoderes->sprite[0].img = surface;
			auxNPoderes = juego->getPoderes();
		}
		txtNPoderes->dibujar(screen);
	}
	barra_poder->selFrame(juego->getBarraPoder() );
	barra_poder->dibujar(screen);
	
	// dibujar poderes
	if (juego->getPoderes() > 0) {
		poderes->selFrame(juego->getPoderSel());
	} else {
		poderes->selFrame(0);
	}
	poderes->dibujar(screen);
	
	
	// dibujar luces
	if (i->getIntercomAbierto() == 1) {
		if (auxPersonaje != i->getPersonajeIntercom()) {
			surface = f->escribirTexto(0, 10, i->getNombrePersonajeIntercom(), 255, 230, 23, 0, 0, 0);
			txtPersonaje->sprite[0].img = surface;
			auxPersonaje = i->getPersonajeIntercom();
		}
		luces->selFrame(1);
		txtPersonaje->dibujar(screen);
	} else {
		luces->selFrame(0);
	}
	luces->dibujar(screen);
	
	// dibujar puntos y texto de nivel y nombre de fase
	// puntos
	if (auxPuntos != juego->getPuntos()) {
		sprintf (tmpuntos, "%d", juego->getPuntos());
		surface = f->escribirTexto(0, sizeFontPuntos, tmpuntos, 255, 255, 255, 0, 0, 0);
		txtPuntos->sprite[0].img = surface;
		auxPuntos = juego->getPuntos();
	}
	txtPuntos->dibujar(screen);
	// fase y nivel
	if (auxNivel != juego->getNivel()) {
		surface = f->escribirTexto(0, sizeFontCartel, juego->getTituloNumeroFase(), 255, 230, 23, 0, 0, 0);
		txtNivel->sprite[0].img = surface;
		surface = f->escribirTexto(0, sizeFontCartel-1, juego->getTituloNombreCortoFase(), 255, 255, 255, 0, 0, 0);
		txtFase->sprite[0].img = surface;
		auxNivel = juego->getNivel();
	}
	txtNivel->dibujar(screen);
	txtFase->dibujar(screen);

	
	// dibujar vidas
	for (int j = 0; j < juego->getVidas(); j++) {
		vida[j]->dibujar(screen);
	}
	
}

void Barra::unLoad() {
	int i;

	for (i=0; i < 7; i++) {
		vida[i]->unLoad();
	}
	
	barra->unLoad();
	barra_poder->unLoad();
	cangrejo->unLoad();
	luces->unLoad();
	poderes->unLoad();
	compuerta->unLoad();
	txtNivel->unLoad();
	txtPuntos->unLoad();
	txtNPoderes->unLoad();
	txtFase->unLoad();
	txtPersonaje->unLoad();
	
}
