/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */

#ifndef EXPLOSION_H_
#define EXPLOSION_H_

#include <SDL.h>
#include "defines.h"
#include "elementos.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

class Elemento;
class Frame;

typedef struct
{
	float x; // 1 para play y 0 para stop
	float y;
	bool activo;
	bool swExplotar;
	int jefeFase;
} ExplosionJefe;

class Explosion {
	
private:
	Elemento *cangrejo, *purpo;
	Elemento *explosion_navepeq[MAXENE_GEN1];
	Elemento *explosion_gav1[MAXENE_GEN1];
	Elemento *explosion_gav2[MAXENE_GEN1];
	Elemento *explosion_navemed[MAXENE_GEN2*2];
	Elemento *explosion_navegr[MAXENE_GEN3*2];
	Elemento *explosion_dispgr[MAXDISP_GR];
	Elemento *explosion_cangrebot[MAXENE_MARINOS];
	Elemento *explosion_pulpo[MAXENE_MARINOS];
	Elemento *explosion_lancha[MAXENE_AUTOMARINO];
	Elemento *explosion_caseta[MAXENE_CONSTRUCCIONES];
	Elemento *explosion_pompagr[MAXDISP_POMPA];
	Elemento *explosion_pompapeq[MAXDISP_POMPA];
	Elemento *explosion_coche[MAXENE_CSIMPLE*2];
	Elemento *explosion_med[MAXEXP_MED];
	Elemento *explosion_med1[MAXEXP_MED];
	Elemento *explosion_dispgr_azul[MAXDISP_GR];
	Elemento *explosion_gr0[MAXEXP_MED];
	Elemento *explosion_barrera[MAXENE_EXPBARRERAS];
	Elemento *explosion_tanque[MAXENE_TANQUE];
	Elemento *explosion_yate[MAXENE_YATE];
	int elementoLibre (int ele);
	int ciclos;
	ExplosionJefe explosionJefe;
public:
	Explosion(SDL_Surface *screen);
	void crearExplosionJefe1(float x, float y) { explosionJefe.x = x; explosionJefe.y = y; explosionJefe.activo = true; explosionJefe.swExplotar = true; explosionJefe.jefeFase = 1; }
	bool getExplosionJefe1() { return explosionJefe.activo; }
	void dibujarExplosionJefe();
	
	void crearExplosionJefe2(float x, float y) { explosionJefe.x = x; explosionJefe.y = y; explosionJefe.activo = true; explosionJefe.swExplotar = true; explosionJefe.jefeFase = 2; }
	bool getExplosionJefe2() { return explosionJefe.activo; }
	//void dibujarExplosionJefe2();
	
	void crearExplosion (int ele, float x, float y);
	void dibujarExplosionTierra(SDL_Surface *screen);
	void dibujarExplosionAire(SDL_Surface *screen);
	void iniciar();
	void unLoad();
};


#endif /* EXPLOSION_H_ */
