/*
 * Tirititran es un juego de naves en 2D ambientado en Cádiz
 * Copyright (C) 2004  Javier Pérez Pacheco
 *
 * Este juego tienen licencia Creative Commons y se permite
 * su modificacion y utilizacion libremente siempre y cuando se
 * cite al autor original y se comparta con la misma licencia.
 * No se permite su uso comercial.
 * 
 * Para mas informacion visite la web:
 * http://creativecommons.org/licenses/by-nc-sa/2.0/es/
 *
 * PROGRAMADOR
 * Javier Pérez Pacheco
 * Cadiz (Spain)
 * javi.pacheco@terra.es
 *
 * GRAFISMO Y 3D
 * Jesus Carrasco
 * Cadiz (Spain)
 * carrasco.carrasco@gmail.com
 *
 * MUSICA Y GRAFISMO
 * Shano Lores
 * Cadiz (Spain)
 * shano@mail.ono.es
 *
 */
 
 
#ifndef TIEMPO_H_
#define TIEMPO_H_

#include <SDL.h>
#include "defines.h"
#include "elementos.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#define MAXNIEVE 160
#define MAXLLUVIA 200
#define MAXCARNAVAL 60

class Elemento;
class Frame;
class Juego;

class Tiempo {

private:
	//int niebla_indice, niebla_indice_in;
	int tiles_niebla;
	//Elemento *niebla[8];
	int nubes_indice, nubes_indice_in;
	int tiles_nubes;
	//Elemento *nubes[18];
	char *mapa_niebla;//[1171]
	char *mapa_nubes;//[1171]
	int velocidad_niebla;
	int velocidad_nubes;

	char *nt;

	Elemento *nieve[MAXNIEVE];
	int ciclosNieve;
	Elemento *lluvia[MAXLLUVIA];
	Elemento *carnaval[MAXCARNAVAL];
	int ciclosCarnaval;
	int activarNieve, activarLluvia, activarCarnaval;


	// niebla
	
	Elemento *niebla[MAX_NIEBLA];
	
	// nubes
	
	Elemento *nubes[MAX_NUBES];

public:
	Tiempo();
	char* BufferFromRar(char *fileRar, char *file);

	void CargarNiebla();
	void dibujarNiebla (SDL_Surface *screen);
	void CargarNubes();
	void dibujarNubes (SDL_Surface *screen);
	void CargarNieve();
	void dibujarNieve (SDL_Surface *screen);
	void CargarLluvia();
	void dibujarLluvia (SDL_Surface *screen);
	void CargarCarnaval ();
	void dibujarCarnaval (SDL_Surface *screen);
	void iniciar();
	void playNiebla();
	void stopNiebla() { velocidad_niebla = 0; }
	void playNubes();
	void stopNubes() { velocidad_nubes = 0; }
	void playNieve();
	void stopNieve();
	int getPlayNieve () { return activarNieve; }
	void playLluvia();
	void stopLluvia();
	int getPlayLluvia () { return activarLluvia; }
	void playCarnaval();
	void stopCarnaval();
	int getPlayCarnaval () { return activarCarnaval; }
	void unLoad();
};


#endif /* TIEMPO_H_ */
